<?php
	$t = 25;

	function CreateDomain($size) {
		for($i = 1; $i <= $size; $i++)
			$array[] = "$i";
		return $array;
	}

	function Entropy($prob, $base = 2) {
		foreach ($prob as $p) {
			if($p != 0) 
				$e += $p * log($p, $base);
		}
		return -$e;
	}
	
	function Sums($arr, $domain, $noAns = '?') {
		foreach ($domain as $value) {
			$sums[$value] = 0;
		}
		foreach ($arr as $value) {
		 	if($value != $noAns)
				$sums[$value]++;
		}
		return $sums;
	}	
	
	function CountNoAns($arr, $noAns = '?') {
		foreach ($arr as $value) {
		 	if($value == $noAns)
				$sums++;
		}
		return $sums;
	}	
	
	function Probability($quest, $domain, $noAns = '?') {
		$sums = Sums($quest, $domain);
		foreach ($sums as $value) 
			$size += $value;
		foreach ($sums as $key => $value) 
			@$prob[$key] = $value/$size;
		return $prob;
	}	

	function Uncertainty($quest, $domain, $t, $noAns = '?') {
		$sums = Sums($quest, $domain);
		$size = count($quest);
		$base = count($domain);
		$min_unc = $quest; // Array for minimizing uncertainty
		$max_unc = $quest; // Array for maximizing uncertainty

		$maxKeys = array_keys($sums, max($sums));
		$maxKey = $maxKeys[0];

		$t = max($t - ($size - CountNoAns($quest)), 0);

		
		for($i = 0; $i < $size; $i++) {
			if(!$t) { break; }
			if($quest[$i] == $noAns) {
				$t--;
				$minKeys = array_keys($sums, min($sums));
				$minKey = $minKeys[0];
				$sums[$minKey]++;

				$min_unc[$i] = $maxKey;				
				$max_unc[$i] = $minKey;
			}
		}
	
		$pr_min = Probability($min_unc, $domain, $noAns);
		$pr_max = Probability($max_unc, $domain, $noAns);
		
		return Entropy($pr_max, $base) - Entropy($pr_min, $base);
	}	
	
	function GetUnc($uID = 0) {
		global $t;
		$q = mysql_query("SELECT count(DISTINCT QuestionID) FROM data");
		$row = mysql_fetch_array($q);
		$num_of_q = $row[0];

		for($i = 0; $i < $num_of_q; $i++)
			for($j = 0; $j < $t; $j++)
				$dataset[$i][$j] = '?';	
		$i = 0;
		$q = mysql_query("SELECT QuestionID, count(*) FROM answers GROUP BY QuestionID;");
		while($row = mysql_fetch_array($q)) {
			$qID = $row[0];
			$count = $row[1];
			$domains[$qID] = $count;
		}	
		$q = mysql_query("SELECT QuestionID, AnswerID, count(*) FROM data GROUP BY QuestionID, AnswerID");
		while($row = mysql_fetch_array($q)) {
			$qID = $row[0];	
			if($qID != $old_qID) {
				$QIDs[$i] = $qID;
				$i++;
				$old_qID = $qID;
				$j = 0;
			}
			$aID = $row[1];
			$count = $row[2];
			for($k = 0; $k < $count; $k++) {
				$dataset[$i-1][$j] = $aID;
				$j++;
			}
		}
		for($k = 0; $k < $num_of_q; $k++) {
			$a = Uncertainty($dataset[$k], CreateDomain($domains[floor($QIDs[$k]/1000) * 1000]), $t);
			$unc[] = array($a, $QIDs[$k]);
		}
		rsort($unc);
		return $unc;
	}	
	
?>